package com.nisum.junitpractice.demo;

import org.junit.Assert;
import org.junit.jupiter.api.*;
import org.junit.jupiter.params.ParameterizedTest;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Arrays;
import java.util.Collection;

@SpringBootTest
public class CalculatorTests {
   private final Calculator calculator = new Calculator();

    @BeforeAll // same as JUnit4's @BeforeClass
    static void beforeAll() {
        System.out.println("Before Class");
    }

   @BeforeEach // same as JUnit4's @Before
   public void beforeTest() {
       System.out.println("Before");
   }

    @AfterAll // same as JUnit4's @AfterClass
    static void afterAll() {
        System.out.println("After Class");
    }

    @AfterEach // same as JUnit4's @After
    public void afterTest() {
        System.out.println("After");
    }

    @Test
    void calculateAdd() {
        int result = calculator.add(5, 5);
        Assertions.assertEquals(10, result, "Failed - calculate add");
    }

    @Test
    void calculateSubtract(){
        int result = calculator.subtract(8, 6);
        Assertions.assertTrue(result == 2, "Failed - Calculate subtract");
    }

    @Test
    void calculateMultiply(){
        int result = calculator.multiply(25, 2);
        Assertions.assertEquals(50, result, "Failed - Calculate multiply");
    }

    @Disabled // same as JUnit4's @Ignore
    @Test
    void calculateDivide(){
        Assertions.assertEquals(3, calculator.divide(60, 20), "Failed - Calculate divide");
    }

    @Test
    void exponent() {
        double result = calculator.exponent(12);
        Assertions.assertEquals(144, result, "Failed - Calculate exponent");
        Assertions.assertNotEquals(24, result, "Failed - Calculate exponent");
    }
}
